<?php

namespace Ems\Logic\ProcessamentoSolicitacao;

use Ems\Util\Utils;
use Util\{ DateUtil, NovoCodigo, Repositories };

class ProcessamentoSolicitacaoUtil {

    public static function retornaHistoricoAtualPorPessoa($nrorg, $nrpessoa, $dtmescompetenc){
        $qb = Utils::getEntityManager()->createQueryBuilder();
        $gpePessoah = Repositories::GPE_PESSOAH;
        $pessoah = $qb
            ->select('p')
            ->from($gpePessoah, 'p')
            ->where('p.nrorg = :nrorg')
            ->andWhere('p.nrpessoa = :nrpessoa')
            ->andWhere('p.dtmescompetenc <= :dtmescompetenc')
            ->orderBy('p.dtmescompetenc', 'DESC')
            ->setParameters(array('nrorg' => $nrorg, 'nrpessoa' => $nrpessoa, 'dtmescompetenc' => $dtmescompetenc))
            ->getQuery()
            ->getResult();
        return current($pessoah);
    }

    public static function novoHistoricoPessoa(
        $nrorg, $nrpessoa, $dtmescompetencia, $nmpessoa, $apelido, $nrCertidaoNascimento, $dtNascimento, $idSexo,
        $nrCondicaoFisica, $nrCPF, $nrCTPS, $nrSerieCTPS, $sgufCTPS, $dtCTPS, $nrPIS, $dtPIS, $nrInscricaoINSS,
        $nrInscricaoISS, $cdEstadoCivil, $nrCertidaoCasamento, $dtCasamento, $idIsentoTituloEleitor, $nrTituloEleitor,
        $nrSecaoEleitoral, $nrZonaEleitoral, $nrHabilitacao, $dtHabilitacao, $dtValidadeHabilitacao,
        $categoriaHabilitacao, $nrCategoriaMilitar, $nrCertificadoReservista, $dsCertificadoReservista,
        $dtCertificadoReservista, $cdExpedicaoCertificadoReservista, $nrRaca, $idGrupoSanguineo, $idFatorRH, $cdpais,
        $sgEstado, $cdMunicipio, $nrRg, $orgaoExpedidorRG, $sgExpedidorRG, $dsLocalExpedicaoRG, $dtExpedicaoRG,
        $nrNacionalidade, $nrGrauInstrucao, $pronometrat = null,  $nranochegapais = null,
        $nrdocuestrang = null, $idpesnaturaliza = null, $dtnaturalizapes = null, $idposvistoperm = null,
        $dtpermavisto = null, $nrconselhoreg = null, $nrinscrconsreg = null, $dtexconsreg = null,
        $sgufconsreg = null, $cdtpbaixapag = null, $nrlivrocertnasc = null, $nrfolhacertnasc = null, $dscomplcertnasc = null,$nrregctpspes = null,
        $nrclassestrang = null, $dsexpdocestr = null, $dtchegadapais = null, $idcotapcd = null
    )
    {
        $gpePessoah = Repositories::GPE_PESSOAH;
        $pessoah = new $gpePessoah;

        //setDadosPrincipais
        list($primeiroNome, $meioNome, $ultimoNome) = Utils::decompoeNomePessoa($nmpessoa);

        $pessoah->setNrorg($nrorg);
        $pessoah->setNrpessoa($nrpessoa);
        $pessoah->setNmpessoa($nmpessoa);
        $pessoah->setDsprinomepess($primeiroNome);
        $pessoah->setDsnomemeiopess((strlen($meioNome)> 20) ? substr($meioNome, 0, 20) : $meioNome);
        $pessoah->setDsultnomepess($ultimoNome);
        $pessoah->setDsapelidopess($apelido);
        $pessoah->setDtmescompetenc($dtmescompetencia);
        $pessoah->setDtnascpessoa($dtNascimento);
        $pessoah->setNrcertnascpes($nrCertidaoNascimento);
        $pessoah->setNrlivrocertnasc($nrlivrocertnasc);
        $pessoah->setNrfolhacertnasc($nrfolhacertnasc);
        $pessoah->setDscomplcertnasc($dscomplcertnasc);

        //setRegistroIdentidade
        $pessoah->setNrcpfpessoa($nrCPF);
        $pessoah->setNrrgpessoa($nrRg);
        $pessoah->setCdexrgpessoa($orgaoExpedidorRG);
        $pessoah->setSgufrgpessoa($sgExpedidorRG);
        $pessoah->setDslocalexrgpes($dsLocalExpedicaoRG);
        $pessoah->setDtexrgpessoa($dtExpedicaoRG);

        //setLocal
        $pessoah->setNrnacionalid($nrNacionalidade);
        $pessoah->setCdpais($cdpais);
        $pessoah->setSgestado($sgEstado);
        $pessoah->setCdmunicipio($cdMunicipio);

        //setImigrante
        $pessoah->setNranochegapais($nranochegapais);
        $pessoah->setNrdocuestrang($nrdocuestrang);
        $pessoah->setIdpesnaturaliza($idpesnaturaliza);
        $pessoah->setDtnaturalizapes($dtnaturalizapes);
        $pessoah->setIdposvistoperm($idposvistoperm);
        $pessoah->setDtpermavisto($dtpermavisto);
        $pessoah->setNrclassestrang($nrclassestrang);
        $pessoah->setDsexpdocestr($dsexpdocestr);
        $pessoah->setDtchegadapais($dtchegadapais ? DateUtil::getDataDeString($dtchegadapais) : null);

        //setDadosCarteiraTrabalho
        $pessoah->setNrctpspessoa($nrCTPS);
        $pessoah->setNrseriectpspes($nrSerieCTPS);
        $pessoah->setSgufctpspes($sgufCTPS);
        $pessoah->setDtctpspessoa($dtCTPS);
        $pessoah->setNrregctpspes($nrregctpspes);

        //setDadosImpostos
        $pessoah->setNrpispaseppes($nrPIS);
        $pessoah->setDtinscpispasep($dtPIS);
        $pessoah->setNrinscinsspes($nrInscricaoINSS);
        $pessoah->setNrinscisspes($nrInscricaoISS);

        //setDadosCivis
        $pessoah->setCdestacivil($cdEstadoCivil);
        $pessoah->setNrcertcasapes($nrCertidaoCasamento);
        $pessoah->setDtcasapessoa($dtCasamento);

        //setDadosEleitorais
        $pessoah->setIdisentituelei($idIsentoTituloEleitor);
        $pessoah->setNrtitueleipes($nrTituloEleitor);
        $pessoah->setNrsecaeleipes($nrSecaoEleitoral);
        $pessoah->setNrzonaeleipes($nrZonaEleitoral);

        //setDadosHabilitacaoVeiculo
        $pessoah->setNrcarthabpes($nrHabilitacao);
        $pessoah->setDthabcartpes($dtHabilitacao);
        $pessoah->setDtvalhabcartpes($dtValidadeHabilitacao);
        $pessoah->setDscateghabcart($categoriaHabilitacao);

        //setDadosMilitares
        $pessoah->setNrcatmilitarpe($nrCategoriaMilitar);
        $pessoah->setNrcertresepes($nrCertificadoReservista);
        $pessoah->setDscategcertrese($dsCertificadoReservista);
        $pessoah->setDtcertresepes($dtCertificadoReservista);
        $pessoah->setCdexcertresepes($cdExpedicaoCertificadoReservista);

        //setDadosFisicos
        $pessoah->setIdsexopessoa($idSexo);
        $pessoah->setNrracapessoa($nrRaca);
        $pessoah->setNrcondfispes($nrCondicaoFisica);
        $pessoah->setIdgrupsangupes($idGrupoSanguineo);
        $pessoah->setIdcotapcd($idcotapcd);
        $pessoah->setIdfatorrhpes($idFatorRH);

        //setDadosAdicionais
        $pessoah->setNrgrauinstr($nrGrauInstrucao);
        $pessoah->setNrconselhoreg($nrconselhoreg);
        $pessoah->setNrinscrconsreg($nrinscrconsreg);
        $pessoah->setDtexconsreg($dtexconsreg);
        $pessoah->setSgufconsreg($sgufconsreg);
        $pessoah->setCdtpbaixapag($cdtpbaixapag);

        if($pronometrat) {
            $pessoah->setDspronometrat($pronometrat);
        }else{
            $pronomeTratamento = Utils::getPronomeTratamento($cdEstadoCivil, $idSexo);
            $pessoah->setDspronometrat($pronomeTratamento);
        }

        $pessoah->setDtinclusao(DateUtil::getDataAtual());
        $pessoah->setNrorginclusao(Utils::getParamters()->getNrorg());
        $pessoah->setCdoperinclusao(Utils::getParamters()->getCdoperador());
        $pessoah->setDtultatu(DateUtil::getDataAtual());
        $pessoah->setNrorgultatu(Utils::getParamters()->getNrorg());
        $pessoah->setCdoperultatu(Utils::getParamters()->getCdoperador());

        $pessoah->setNrpessoah(NovoCodigo::geraCodigo(Utils::getParamters()->getNrorg(), 'GPE_PESSOAH', 1, 12, true));
        
        Utils::getEntityManager()->persist($pessoah);
        Utils::getEntityManager()->flush($pessoah);
        return $pessoah;
    }

    public static function retornaUltimoHistoricoVinculoCompetencia($nrorg, $nrvinculom, $dtmescompetenc) {
        $gpevinculoh = Repositories::GPE_VINCULOH;
        $qb = Utils::getEntityManager()->createQueryBuilder();
        $query = $qb->select("h")
            ->from($gpevinculoh, "h")
            ->where("h.nrorg = :nrorg")
            ->andWhere("h.nrvinculom = :nrvinculom")
            ->andWhere("h.dtmescompetenc = (select max(h1.dtmescompetenc) from $gpevinculoh h1 where h1.nrorg = h.nrorg and h1.nrvinculom = h.nrvinculom and h1.dtmescompetenc <= :dtmescompetenc)")
            ->setParameters(array('nrorg'=>$nrorg, 'nrvinculom'=>$nrvinculom, 'dtmescompetenc'=>$dtmescompetenc))
            ->getQuery();
        $historico = $query->getSingleResult();

        return $historico;
    }

    public static function novoAlteSalario($nrorg, $nrvinculom, $dtaltesalario, $nrocorrencia, $nrtipoaltera, $nrtpmodalidsal, $idtpsalario, $novoVlrSalario) {

        if (!$dtaltesalario) {
            throw new \Exception("Solicitação sem data ou com data de alteração inválida. Favor reprovar e incluir uma nova solicitação.");
        }
        
        if (!$nrtipoaltera) {
            throw new \Exception("Solicitação sem tipo de alteração informado. Favor reprovar e incluir uma nova solicitação.");
        }
        
        /** @var \Teknisa\Model\Gestaopessoas\Entities\GpeAltesalario $alteSalario */
        $gpeAltesalrio = Repositories::GPE_ALTESALARIO;
        $alteSalario = new $gpeAltesalrio;
        $alteSalario->setNrorg($nrorg);
        $alteSalario->setNrvinculom($nrvinculom);
        $alteSalario->setDtaltesalario($dtaltesalario);
        $alteSalario->setNrocorrencia($nrocorrencia);
        $alteSalario->setNrtipoaltera($nrtipoaltera);
        $alteSalario->setNrtpmodalidsal($nrtpmodalidsal);
        $alteSalario->setIdtpsalario($idtpsalario);
        $alteSalario->setVrsalario($novoVlrSalario);
        $alteSalario->setDtinclusao(DateUtil::getDataAtual(false));
        $alteSalario->setNrorginclusao(Utils::getParamters()->getNrorg());
        $alteSalario->setCdoperinclusao(Utils::getParamters()->getCdoperador());
        $alteSalario->setNraltesalario(NovoCodigo::geraCodigo(Utils::getParamters()->getNrorg(), 'GPE_ALTESALARIO', 1, 12, true));
        Utils::getEntityManager()->persist($alteSalario);
        Utils::getEntityManager()->flush();

        return $alteSalario;
    }

    public static function novoAlteEscala($nrorg, $nrvinculom, $nrturno, $nrmotivoescala, $nrescalatrabm, $dtiniescala) {
        
        $gpeAlteescala = Repositories::GPE_ALTEESCALA;
        $alteEscala = new $gpeAlteescala;
        $alteEscala->setNrorg($nrorg);
        $alteEscala->setNrvinculom($nrvinculom);
        $alteEscala->setNrturno($nrturno);
        $alteEscala->setNrmotivoescala($nrmotivoescala);
        $alteEscala->setNrescalatrabm($nrescalatrabm);
        $alteEscala->setDtiniescala($dtiniescala);
        $alteEscala->setDtinclusao(DateUtil::getDataAtual(false));
        $alteEscala->setNrorginclusao(Utils::getParamters()->getNrorg());
        $alteEscala->setCdoperinclusao(Utils::getParamters()->getCdoperador());
        $alteEscala->setNralteescala(NovoCodigo::geraCodigo(Utils::getParamters()->getNrorg(), 'GPE_ALTEESCALA', 1, 12, true));
        Utils::getEntityManager()->persist($alteEscala);
        Utils::getEntityManager()->flush();

        return $alteEscala;
    }

    public static function atualizaAlteEscala($nrorg, $nrvinculom, $nrescalatrabm, $dtfimescala,$dtatual,$cdoperador) {
        $sql = <<<SQL
            UPDATE GPE_ALTEESCALA 
            SET DTFIMESCALA = :P_DTFIMESCALA,
            DTULTATU = :P_DTATUAL,
            NRORGULTATU = :P_NRORG,
            CDOPERULTATU = :P_CDOPERADOR
            WHERE DTINIESCALA = (
                SELECT MAX(DTINIESCALA) 
                FROM GPE_ALTEESCALA 
                WHERE NRORG = :P_NRORG 
                AND NRVINCULOM = :P_NRVINCULOM 
                AND DTFIMESCALA IS NULL
            )
            AND NRORG = :P_NRORG 
            AND NRVINCULOM = :P_NRVINCULOM 
            AND DTINIESCALA <= :P_DTFIMESCALA
            AND DTFIMESCALA IS NULL
SQL;
        return Utils::getEntityManager()->getConnection()->prepare($sql)
            ->execute(array(
                "P_NRORG"           => $nrorg,
                "P_DTFIMESCALA"     => $dtfimescala,
                "P_NRVINCULOM"      => $nrvinculom,
                "P_DTATUAL"         => $dtatual,
                "P_CDOPERADOR"      => $cdoperador
            )
        );
    }

    public static function atualizaEscalaVinculoh($nrorg, $nrvinculom, $nrescalatrabm, $dtatual, $cdoperador) {
        $sql = <<<SQL
            UPDATE GPE_VINCULOH 
            SET NRESCALATRABM = :P_NRESCALATRABM,
            DTULTATU = :P_DTATUAL,
            NRORGULTATU = :P_NRORG,
            CDOPERULTATU = :P_CDOPERADOR
            WHERE DTMESCOMPETENC = (
                SELECT MAX(DTMESCOMPETENC) 
                FROM GPE_VINCULOH 
                WHERE NRORG = :P_NRORG 
                AND NRVINCULOM = :P_NRVINCULOM 
            )
            AND NRORG = :P_NRORG
            AND NRVINCULOM = :P_NRVINCULOM
SQL;
        return Utils::getEntityManager()->getConnection()->prepare($sql)
            ->execute(array(
                "P_NRORG"           => $nrorg,
                "P_NRVINCULOM"      => $nrvinculom,
                "P_NRESCALATRABM"   => $nrescalatrabm,
                "P_DTATUAL"         => $dtatual,
                "P_CDOPERADOR"      => $cdoperador
            )
        );
    }

    public static function novoHistoricoVinculo($nrorg, $nrvinculom, $dtmescompetenc, $nrsitufuncm, $nrcargo, $nrescalatrabm,
                                  $idcontribuisind, $nrdependir, $nrdependsfam, $dtbaseferias, $idremuneracao,
                                  $idtppagamento, $nrestrutlegal, $nrestrutgeren, $nrtpmodalidsal, $idmultvinc,
                                  $nrfuncao, $cdcontribindividual, $nrtpmovtransfm, $dtfimcontrdetermin,
                                  $nrestrutsind, $confidencial, $cdmatriculaEsocial = null, $idpagpropfer13 = null, $idAssocSindicato = 'N')
    {
        /** @var \Teknisa\Model\Gestaopessoas\Entities\GpeVinculoh $vinculoh */
        $gprVinculoh = Repositories::GPE_VINCULOH;
        $vinculoh = new $gprVinculoh;

        $vinculoh->setNrorg($nrorg);
        $vinculoh->setNrvinculom($nrvinculom);
        $vinculoh->setDtmescompetenc($dtmescompetenc);

        $vinculoh->setDtbaseferias($dtbaseferias);
        $vinculoh->setIdmultvinc($idmultvinc);
        $vinculoh->setNrsitufuncm($nrsitufuncm);
        $vinculoh->setNrtpmovtransfm($nrtpmovtransfm);
        $vinculoh->setCdcontribindividual($cdcontribindividual);
        $vinculoh->setDtfimcontrdetermin($dtfimcontrdetermin);

        $vinculoh->setNrcargo($nrcargo);
        $vinculoh->setNrfuncao($nrfuncao);
        $vinculoh->setNrescalatrabm($nrescalatrabm);
        $vinculoh->setIdremuneracao($idremuneracao);
        $vinculoh->setIdtppagamento($idtppagamento);
        $vinculoh->setNrtpmodalidsal($nrtpmodalidsal);

        $vinculoh->setNrdependir($nrdependir);
        $vinculoh->setNrdependsfam($nrdependsfam);
        $vinculoh->setConfidencial($confidencial);

        $vinculoh->setNrestrutlegal($nrestrutlegal);
        $vinculoh->setNrestrutgeren($nrestrutgeren);
        $vinculoh->setNrestrutsind($nrestrutsind);
        $vinculoh->setIdcontribuisind(($idcontribuisind) ? : 'NUNCA');
        $vinculoh->setCdmatriculaesocial($cdmatriculaEsocial);
        $vinculoh->setIdpagpropfer13($idpagpropfer13);
        $vinculoh->setIdassocsindicato($idAssocSindicato);

        $vinculoh->setDtinclusao(DateUtil::getDataAtual());
        $vinculoh->setCdoperinclusao(Utils::getParamters()->getCdoperador());
        $vinculoh->setNrorginclusao(Utils::getParamters()->getNrorg());
        $vinculoh->setDtultatu(DateUtil::getDataAtual());
        $vinculoh->setCdoperultatu(Utils::getParamters()->getCdoperador());
        $vinculoh->setNrorgultatu(Utils::getParamters()->getNrorg());

        $vinculoh->setNrvinculoh(NovoCodigo::geraCodigo(Utils::getParamters()->getNrorg(), 'GPE_VINCULOH', 1, 12, true));
        
        Utils::getEntityManager()->persist($vinculoh);
        Utils::getEntityManager()->flush($vinculoh);
        
        return $vinculoh;
    }

    public static function atualizaDatafimUltimaSituFunc($nrorg, $nrvinculom, $dtinisitufunc) {
        $data = DateUtil::getDataDeString(substr($dtinisitufunc, 0, 10), 'd/m/Y', true);
        $data = DateUtil::subtraiIntervalo($data, 1);
        $datainicio = DateUtil::truncateString($data);

        $gpeAltesitufunc = Repositories::GPE_ALTESITUFUNC;
        $qb = Utils::getEntityManager()->createQueryBuilder();
        $query = $qb->select("a")
            ->from($gpeAltesitufunc, "a")
            ->where("a.nrorg = :nrorg")
            ->andWhere("a.nrvinculom = :nrvinculom")
            ->andWhere("a.dtinisitufunc = (SELECT MAX(b.dtinisitufunc) FROM $gpeAltesitufunc b WHERE b.nrorg = a.nrorg AND b.nrvinculom = a.nrvinculom AND b.dtinisitufunc <= :dtinisitufunc)")
            ->setParameters(array('nrorg'=>$nrorg, 'nrvinculom'=>$nrvinculom, 'dtinisitufunc'=>$datainicio))
            ->getQuery()
            ->getResult();
        $ultimaSituFunc = $query;

        $ultimaSituFunc = empty($ultimaSituFunc) ? $ultimaSituFunc : $ultimaSituFunc[0];
        
        if($ultimaSituFunc && $ultimaSituFunc->getDtfimsitufunc() !== '') {
            $iniSit = DateUtil::truncateString($ultimaSituFunc->getDtinisitufunc());
            $iniSit = DateUtil::getDataDeString($iniSit, 'd/m/Y', true);
            $qtdDias = DateUtil::getQtdeDiasEntre($iniSit, $data);
            $qtdDias++;
            $qtdDias++;

            $ultimaSituFunc->setNrqtdiasitufunc($qtdDias);
            $ultimaSituFunc->setDtfimsitufunc($data);
            Utils::getEntityManager()->persist($ultimaSituFunc);
            Utils::getEntityManager()->flush();
        }

        return $ultimaSituFunc;
    }

    public static function atualizaVabLinhaVinc($nrorg, $nrvinculom, $nrlinhatransp, $dtfimlinhavinc, $dsobslinhavinc, $dtaltelinhavinc, $cdoperador) {

        $vablinhavinc = Repositories::VAB_LINHAVINC;
        $qb = Utils::getEntityManager()->createQueryBuilder();
        $query = $qb->select("a")
            ->from($vablinhavinc, "a")
            ->where("a.nrorg = :nrorg")
            ->andWhere("a.nrvinculom = :nrvinculom")
            ->andWhere("a.nrlinhatarifa = :nrlinhatarifa")
            ->setParameters(array('nrorg'=>$nrorg, 'nrvinculom'=>$nrvinculom, 'nrlinhatarifa'=>$nrlinhatransp))
            ->getQuery()
            ->getResult();
        $vablinhavincrow = empty($query) ? $query : $query[0];

        if(!$query) {
            throw new \Exception("Não foram encontrados registros de vale transporte para essa linha neste vínculo para serem excluídos.");
        }
        
        $vablinhavincrow->setDtfimlinhavinc($dtfimlinhavinc);
        $vablinhavincrow->setNrorgultatu($nrorg);
        $vablinhavincrow->setCdoperultatu($cdoperador);
        $vablinhavincrow->setDtultatu($dtaltelinhavinc);
        $vablinhavincrow->setDsobslinhavinc($dsobslinhavinc);

        Utils::getEntityManager()->persist($vablinhavincrow);
        Utils::getEntityManager()->flush();

        return $vablinhavincrow;
    }

    public static function novaAlteSituacaoFuncional($nrorg, $nrvinculom, $nrsitufuncm, $dtinisitufunc, $dtfimsitufunc = null, $nrqtdiasitufunc = null, $nrproximasitufunc = null)
    {
        /** @var \Teknisa\Model\Gestaopessoas\Entities\GpeAltesitufunc $vinculoh */
        $gpeAlteSituFun = Repositories::GPE_ALTESITUFUNC;
        $alteSituFunc = new $gpeAlteSituFun;

        $alteSituFunc->setNrorg($nrorg);
        $alteSituFunc->setNrvinculom($nrvinculom);
        //$alteSituFunc->setObsaltsitfunc($dsobssolicitacao);
        $alteSituFunc->setDtinisitufunc($dtinisitufunc);
        $alteSituFunc->setDtfimsitufunc($dtfimsitufunc);
        $alteSituFunc->setNrsitufuncm($nrsitufuncm);
        $alteSituFunc->setNrqtdiasitufunc($nrqtdiasitufunc);
        $alteSituFunc->setNrproxsitufunc($nrproximasitufunc);
        $alteSituFunc->setDtinclusao(DateUtil::getDataAtual(false));
        $alteSituFunc->setNrorginclusao(Utils::getParamters()->getNrorg());
        $alteSituFunc->setCdoperinclusao(Utils::getParamters()->getCdoperador());
        $alteSituFunc->setNralteSituFunc(NovoCodigo::geraCodigo(Utils::getParamters()->getNrorg(), 'GPE_ALTESITUFUNC', 1, 12, true));
        Utils::getEntityManager()->persist($alteSituFunc);
        Utils::getEntityManager()->flush();

        return $alteSituFunc;
    }

    public static function atualizaVabBeneficiario($nrorg, $nrvinculom, $nrbeneficiom, $dtcancbeneficiario, $dsobsbeneficiario, $cdoperador) {

        $vabBeneficiario = Repositories::VAB_BENEFICIARIO;
        $qb = Utils::getEntityManager()->createQueryBuilder();
        $query = $qb->select("a")
            ->from($vabBeneficiario, "a")
            ->where("a.nrorg = :nrorg")
            ->andWhere("a.nrvinculom = :nrvinculom")
            ->andWhere("a.nrbeneficiom = :nrbeneficiom")
            ->setParameters(array('nrorg'=>$nrorg, 'nrvinculom'=>$nrvinculom, 'nrbeneficiom'=>$nrbeneficiom))
            ->getQuery()
            ->getResult();
        $vabBeneficiariorow = empty($query) ? $query : $query[0];

        if(!$query) {
            throw new \Exception("Não foram identificados registros de vale combustível associados a este vínculo que possam ser excluídos.");
        }
        
        return $vabBeneficiariorow;
    }

}