<?php

namespace Mig\Services;

use Doctrine\ORM\EntityManager;

use Util\Environment;
use Util\Messages;

use Mig\ImportacaoXLS\Importador;

use Util\{
    DateUtil,
    //FileUploader,
    //HCMParameters,
    Repositories,
    //Util
};

use Teknisa\Model\Gestaopessoas\Entities\{GpeAnexos, GpeMigracao};
use \Zeedhi\Framework\ORM\DateTime;

class MigracaoPlanilhaService {
    
    /** @var EntityManager */
    protected $entityManager;

    /** @var Environment */
    protected $environment;
    
    /** @var Importador */
    private $importador;


    public function __construct(
        EntityManager      $entityManager,
        Environment        $environment
        
    ) {
        $this->entityManager            = $entityManager;
        $this->environment              = $environment;
    }
    
    public function importarPlanilha($row): void
    {
        $this->importador = new Importador(
            $row,
            $this->environment,
            $this->entityManager
        );

        $this->importador->importarPlanilha();
    }
    
    public function errosImportacaoPlanilha(): array
    {
        return $this->importador->errosImportacaoPlanilha();
    }


}