CREATE TABLE USR_HORA_EXPORTA (HORA_EXP VARCHAR2(5))
/
DROP FUNCTION GERA_AF_PLATLOG;
/

DROP TYPE GERA_AF_PLATLOG_TABLE;
/

DROP TYPE GERA_AF_PLATLOG_TYPE;
/

CREATE TYPE GERA_AF_PLATLOG_TYPE AS OBJECT
  (DADOS          VARCHAR2(500),
   DSARQENVIOAF   VARCHAR2(250),
   CONTLIN        INT
  );
/

CREATE TYPE GERA_AF_PLATLOG_TABLE AS TABLE OF GERA_AF_PLATLOG_TYPE;
/

CREATE OR REPLACE FUNCTION GERA_AF_PLATLOG
                          (P_CDFORNECED      IN FORNECEDOR.CDFORNECED%TYPE,
                           P_CDFORNERELACAF  IN FORNECEDOR.CDFORNECED%TYPE,
                           P_CLASSIFICACOR   IN VARCHAR)
                          RETURN GERA_AF_PLATLOG_TABLE PIPELINED IS

   OUT_RECORD GERA_AF_PLATLOG_TYPE := GERA_AF_PLATLOG_TYPE (NULL, NULL, 0);
   V_DADOS_CAB         VARCHAR2(500);
   V_DADOS_ITEM        VARCHAR2(500);
   V_CONTLIN           INT := 0;
   V_COUNT_AF          INT := 0;
   V_CONTITEM          INT := 0;
   V_NOMEARQ           VARCHAR2(10)  := '';
   V_FILE_DIR          VARCHAR2(250) := '';
   V_DTINIAPURAFFORN   DATE;
   V_DTFINAPURAFFORN   DATE;
   V_NRSEQAPURAF       VARCHAR2(2000)   := '';
   V_CDPAIS            VARCHAR2(4);
   V_SGESTADO          VARCHAR2(2);
   V_COUNT_APURAF      INT := 0;

BEGIN
   SELECT MAX(DSDIRARQENVIOAF)
     INTO V_FILE_DIR
     FROM PARASUPRI
    WHERE CDFILIAL = '0003';
   IF LENGTH(V_FILE_DIR) > 0 THEN
      IF SUBSTR(V_FILE_DIR, LENGTH(V_FILE_DIR), 1) = '\'THEN
         V_FILE_DIR := V_FILE_DIR||SUBSTR(P_CDFORNERELACAF, 2, LENGTH(P_CDFORNERELACAF));
      ELSE
         V_FILE_DIR := V_FILE_DIR||'\'||SUBSTR(P_CDFORNERELACAF, 2, LENGTH(P_CDFORNERELACAF));
      END IF;
      V_FILE_DIR := V_FILE_DIR||'\'||P_CLASSIFICACOR;

      SELECT LPAD(TO_CHAR(TO_NUMBER(NVL(MAX(NRSEQENVIOAFORN), '0'))+1), 10, '0')
        INTO V_NOMEARQ
        FROM ENVIOAFFORN;

      SELECT CDPAIS, SGESTADO
        INTO V_CDPAIS, V_SGESTADO
        FROM ENDEFORN
       WHERE CDFORNECED = P_CDFORNERELACAF
         AND NVL(IDTPENDEFORN, 'A') = 'P';

      FOR DADOS_CAB IN (SELECT *
                          FROM (SELECT DISTINCT A.CDFORNECED, A.NRAUTOFORN, A.CDFILDEST, A.CDFILLANC, NVL(A.NRSEQAPURAF, '_') NRSEQAPURAF,
                                       C.DTPROGENTAF, '1' TIPO_REGISTRO,  --1
                                       RPAD(A.CDFILDEST||'9'||SUBSTR(A.NRAUTOFORN, 4,8), 20, ' ') NUMERO_PEDIDO_COMPRADOR,  --4
                                       TO_CHAR(A.DTAUTOFORN,'DD/MM/YYYY') DATA_HORA_EMISSAO_PEDIDO, --6
                                       DECODE(A.CDOPERADOR,'000000000069','1','000000000060','1','000000000063','1','000000000065','3','O') TIPO -- 1 PARA RESFRIADOS E CONGELADOS E 2 PARA SECOS
                                  FROM AUTOFORNE A INNER JOIN FORNECEDOR B
                                                      ON A.CDFORNECED=B.CDFORNECED
                                                   INNER JOIN ITEMAUTF C
                                                      ON A.CDFILDEST=C.CDFILDEST
                                                     AND A.NRAUTOFORN=C.NRAUTOFORN
                                                     AND A.CDFILLANC=C.CDFILLANC
                                                   INNER JOIN PRODUTO P
                                                      ON C.CDPRODUTO=P.CDPRODUTO
                                                    LEFT JOIN MARCA M
                                                      ON C.CDMARCA=M.CDMARCA
                                                    LEFT JOIN UNIDMEDIDA U
                                                      ON P.SGUNIDADE=U.SGUNIDADE
                                                    LEFT JOIN PARCMPSUP J
                                                      ON A.CDFILDEST =J.CDFILIAL,
                                       FILIAL FIL, CLIENTE CLI, (SELECT * FROM CLIENFILIAL WHERE IDCLIENPRIN = 'S') CF,
                                       ENDEFILI EF, MUNICIPIO M, APURPRECO
                                 WHERE A.CDFORNECED        = P_CDFORNECED
                                   AND A.CDFILDEST           = EF.CDFILIAL
                                   AND EF.IDTPENDEFILI       = 'P'
                                   AND EF.SGESTADO           = M.SGESTADO
                                   AND EF.CDPAIS             = M.CDPAIS
                                   AND EF.CDMUNICIPIO        = M.CDMUNICIPIO
                                   AND A.CDFILDEST           = FIL.CDFILIAL
                                   AND CF.CDFILIAL           = FIL.CDFILIAL
                                   AND CF.CDCLIENTE          = CLI.CDCLIENTE
                                   --AND C.DTPROGENTAF         >= TRUNC(SYSDATE) + 1 -- DATA DE ENTREGA
                                   AND C.DTPROGENTAF         >= '01/04/2014' -- DATA DE ENTREGA
                                   AND A.CDFILLANC           = '0003'
                                   AND A.IDTIPOLANCAF        <> 'M'
                                   AND NVL(A.IDBAIXAAF, '1') = '7'
                                   AND ((NVL(A.NRSEQENVIOAFORN, '1')      = '1' AND NVL( A.DSMOTIVOENVAFOR, '1')     = '1')
                                    OR  (NVL(A.NRSEQENVIOAFORN, '1')      <> '1' AND NVL( A.DSMOTIVOENVAFOR, '1')    <> '1'))
                                 ORDER BY C.DTPROGENTAF)
                       )
      LOOP
         V_DADOS_CAB := DADOS_CAB.TIPO_REGISTRO || ';' ||
                        DADOS_CAB.CDFILDEST || ';' ||
                        TRIM(DADOS_CAB.NUMERO_PEDIDO_COMPRADOR) || ';' ||
                        DADOS_CAB.DATA_HORA_EMISSAO_PEDIDO  || ';' || 'PEDIDO GRSA' || ';' || TRIM(DADOS_CAB.TIPO) || ';' || REPLACE(DADOS_CAB.CDFORNECED,'J')
                        ||''||DADOS_CAB.CDFILDEST||DADOS_CAB.CDFILLANC||DADOS_CAB.NRAUTOFORN;
         V_CONTLIN               := V_CONTLIN + 1;
         OUT_RECORD.DADOS        := V_DADOS_CAB;
         OUT_RECORD.CONTLIN      := V_CONTLIN;
         OUT_RECORD.DSARQENVIOAF := SUBSTR(V_FILE_DIR||V_NOMEARQ||'.TXT', 1, 250);
         PIPE ROW (OUT_RECORD);
         V_COUNT_AF := V_COUNT_AF + 1;
         V_CONTITEM := 0;

         FOR ITENS IN (SELECT A.NRAUTOFORN, A.IDBAIXAAF, A.CDFILDEST , '2' TIPO_REGISTRO,
                              LPAD(1, 4, '0') SEQUENCIAL_PRODUTO, P.CDARVPROD , M.CDMARCA,
                              LPAD(TRIM(REPLACE(REPLACE(TO_CHAR(C.QTPROGENTAF, '999999D99999', 'NLS_NUMERIC_CHARACTERS=.,'), ',', ''), '.', ',')), 15, '0') QUANTIDADE_PEDIDA,
                              LPAD(TRIM(REPLACE(REPLACE(TO_CHAR(C.VRPREUNIAF, '99999G999D99', 'NLS_NUMERIC_CHARACTERS=.,')||'000', '.', ','), '.', '')), 15, '0') VALOR_LIQUIDO_LINHA_ITEM,
                              TO_CHAR(DTPROGENTAF, 'DD/MM/YYYY') DATA_ENTREGA
                         FROM AUTOFORNE A, ITEMAUTF C, UNIDMEDIDA U, PRODUTO P, PARCMPSUP J, MARCA M
                        WHERE A.CDFILDEST  = C.CDFILDEST
                          AND A.NRAUTOFORN = C.NRAUTOFORN
                          AND A.CDFILLANC  = C.CDFILLANC
                          AND C.CDPRODUTO  = P.CDPRODUTO
                          AND C.CDMARCA    = M.CDMARCA
                          AND P.SGUNIDADE  = U.SGUNIDADE
                          AND A.CDFILDEST  = J.CDFILIAL
                          AND A.NRAUTOFORN = DADOS_CAB.NRAUTOFORN
                          AND A.CDFILDEST  = DADOS_CAB.CDFILDEST
                          AND A.CDFILLANC  = DADOS_CAB.CDFILLANC
                    )
         LOOP
            V_CONTITEM   := V_CONTITEM + 1;
            V_DADOS_ITEM := ITENS.TIPO_REGISTRO || ';' ||
                            V_CONTITEM || ';' ||
                            ITENS.CDARVPROD || ';' ||
                            ITENS.CDMARCA || ';' ||
                            ITENS.QUANTIDADE_PEDIDA || ';' ||
                            ITENS.VALOR_LIQUIDO_LINHA_ITEM || ';' ||
                            ITENS.DATA_ENTREGA;
            V_CONTLIN               := V_CONTLIN + 1;
            OUT_RECORD.DADOS        := V_DADOS_ITEM;
            OUT_RECORD.CONTLIN      := V_CONTLIN;
            OUT_RECORD.DSARQENVIOAF := SUBSTR(V_FILE_DIR||V_NOMEARQ||'.TXT', 1, 250);
            PIPE ROW (OUT_RECORD);
            
            V_COUNT_APURAF := 0;
            SELECT COUNT(1)
              INTO V_COUNT_APURAF
              FROM DUAL
             WHERE INSTR(V_NRSEQAPURAF, DADOS_CAB.NRSEQAPURAF) > 0;

            IF V_COUNT_APURAF = 0  THEN

               V_NRSEQAPURAF := V_NRSEQAPURAF||'_'||DADOS_CAB.NRSEQAPURAF;
            END IF;



         END LOOP;
      END LOOP;
      SELECT MIN(DTINIAPUPREC), MAX(DTFINAPUPREC)
        INTO V_DTINIAPURAFFORN, V_DTFINAPURAFFORN
        FROM APURPRECO
       WHERE INSTR(V_NRSEQAPURAF, NRAPURPREC) > 0
         AND CDFILCENTCMP = '0003';
      IF V_CONTLIN > 0 THEN
         OUT_RECORD.DADOS        := '3'||'_'||V_CDPAIS||'_'||V_SGESTADO||'_'||
                                    TO_CHAR(V_DTINIAPURAFFORN, 'DD/MM/YYYY')||'_'||
                                    TO_CHAR(V_DTFINAPURAFFORN, 'DD/MM/YYYY')||'_'||
                                    V_COUNT_AF||V_NRSEQAPURAF;
         OUT_RECORD.CONTLIN      := V_CONTLIN;
         OUT_RECORD.DSARQENVIOAF := SUBSTR(V_FILE_DIR||V_NOMEARQ||'.TXT', 1, 250);
         PIPE ROW (OUT_RECORD);
      END IF;
   END IF;
   RETURN;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GERA_AF_PLATLOG','5.42.XXX'); END;
/